module Ooz
  module Base
    class Ooze < Base::Model
      overridable_const :evolution_class, Base::Evolution
      overridable_const :section_class, Base::Section
      overridable_const :field_factory_class, Base::FieldFactory
      overridable_const :force_class, Base::Force

      passthrough  :_id, :template_id, :name, :organization_id, :patch_ver, to: :doc
      passthrough  :created_at, :updated_at, :time_zone, to: :doc
      passthrough  :state, :status, to: :doc
      passthrough  :votes_enabled, :upvotes, :downvotes, to: :doc
      passthrough  :tags, :compiled_tags, :base_tags, to: :doc
      passthrough  :theme_id, :icon, :ss_error, to: :doc
      passthrough  :disable_direct_permissions, :task_priority, to: :doc

      passthrough_cls :evolution, to: :doc, klass: :evolution_class
      passthrough_arr :flow_nodes, to: :doc, klass: :section_class
      passthrough_arr :membranes, to: :doc, klass: :field_factory_class
      passthrough_arr :forces, to: :doc, klass: :force_class

      def initialize(*args)
        super(*args)

        #pp evolution_class
      end

    end
  end
end
