module Ooz
  module Base
    class Stage < Base::Model
    end
  end
end

require_relative "stage/task"

module Ooz
  module Base
    class Stage
      overridable_const :task_completion_class, Base::Stage::Task::Completion
      overridable_const :task_review_class, Base::Stage::Task::Review

      passthrough  :_id, :name, :ordering, :state, :patch_ver, to: :doc
      passthrough  :created_at, :updated_at, to: :doc
      passthrough  :creator_enabled, :creator_editable, to: :doc
      passthrough  :tags, :compiled_tags, to: :doc
      passthrough  :flow_node_ids, to: :doc
      passthrough  :disable_direct_permissions, :lock_after_completion, to: :doc
      passthrough  :task_priority, to: :doc

      passthrough_cls :completion_task_config, to: :doc, klass: :task_completion_class
      passthrough_cls :review_task_config, to: :doc, klass: :task_review_class
    end
  end
end
