module Ooz
  module Base
    class Stage
      class Task < Base::Model
      end
    end
  end
end

require_relative "task/priority"
require_relative "task/strategy"
require_relative "task/strategy_factory"
require_relative "task/action"
require_relative "task/action_factory"
require_relative "task/scheduled_callback"
require_relative "task/completion"
require_relative "task/review"

module Ooz
  module Base
    class Stage
      class Task
        overridable_const :strategy_class, Base::Stage::Task::StrategyFactory
        overridable_const :scheduled_callback_class, Base::Stage::Task::ScheduledCallback
        passthrough  :_id, :_type, :patch_ver, to: :doc
        passthrough  :due_enabled, :due_ctr, :due_unit, to: :doc
        passthrough_arr :strategies, to: :doc, klass: :strategy_class
        passthrough_cls :default_strategy, to: :doc, klass: :strategy_class
        passthrough_arr :scheduled_callbacks, to: :doc, klass: :scheduled_callback_class
      end
    end
  end
end
