module Ooz
  module Model
    class Field < Base::Field
      module Methods
        def self.included(base)
          base.send(:include, InstanceMethods)
        end

        module InstanceMethods
          def bindings
            ooze.bindings_by_field[_id] || []
          end

          def section
            ooze.sections_by_field[_id]
          end

          def stages
            section.stages
          end
        end
      end

      include Methods
      
    end
  end
end

require_relative "field/undefined"
require_relative "field/select"
require_relative "field/date"
require_relative "field/plain_text"
require_relative "field/rich_text"
require_relative "field/number"
require_relative "field/gauge"
require_relative "field/people"
require_relative "field/tag_field"
require_relative "field/cross_reference"
require_relative "field/file"
require_relative "field/image_gallery"
require_relative "field/checklist"
