module Ooz
  module Model
    class Section < Base::Section

      def stages
        ooze.stages_by_section[_id] || []
      end

      def orphan?
        ooze.stages? && stages.empty?
      end

      def split?
        _type == "Enzyme::Flow::SplitNode"
      end

      def compact?
        !split?
      end

      def field_ids
        split? ? (left_membrane_ids || []) + (right_membrane_ids || []) : membrane_ids
      end

      def fields
        collect_from(field_ids, ooze.fields_hash)
      end

    end
  end
end
